<?php
	
	set_time_limit (1500);
	
	class onBackupCronBackup extends cmsAction {
		
		public function run(){
			
			$start = microtime(true); // Получаем время старта скрипта
			
			$config = cmsConfig::getInstance();
			
			/* Получаем количество свободного места на диске */
			$bytes = disk_free_space("."); 
			
			/* Функция преобразование байт в другие величины */
			function showSize($bytes){
				$si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'EB', 'ZB', 'YB' );
				$base = 1024;
				$class = min((int)log($bytes , $base) , count($si_prefix) - 1);
				return sprintf('%1.2f' , $bytes / pow($base,$class)) . ' ' . $si_prefix[$class];
			}
			
			/* Функция получения размера папки */
			function recursiveDirSize($path) {
				$folder = 0;
				$ite = new RecursiveDirectoryIterator($path);
				
				foreach(new RecursiveIteratorIterator($ite) as $cur) {
					$folder += $cur->getSize();
				}
				
				return $folder;
			}
			
			function runtime($runtime) {
				if ($runtime >= 60)
				{return "<br/> Скрипт выполнялся ". round($runtime / 60,  0) . " мин. ". round($runtime % 60,  0) ." сек.<br/>";}
				else {
				return '<br/>Скрипт выполнялся '. round($runtime) . 'сек.';}	
				
			}
			
			/* Получаем размер базы данных */
			$size = $this->model->db->fetchAssoc($this->model->db->query("SELECT SUM( data_length + index_length ) AS 'size'
			FROM information_schema.TABLES
			WHERE table_schema = '{$config->db_base}'
			LIMIT 1"));
			
			/* Если есть место для бэкапа - продолжаем */
			if ($bytes > $size['size']){
				
				
				/* Если папка для бэкапов еще не создана - создаем её */
				if (!file_exists( PATH . DIRECTORY_SEPARATOR . $this->options['folder_name'])){
				mkdir( PATH . DIRECTORY_SEPARATOR . $this->options['folder_name'], 0700);}
				
				/* Генерация имени файла архива */
				$filename='db_backup_'.date('d-m-Y_H-i').'.sql.gz';
				
				/* Выполняем дамп базы и архивирование */
				$result = exec('mysqldump '.$config->db_base.' --password='.$config->db_pass.' --user='.$config->db_user.' --single-transaction | gzip -f9 > ' . PATH . DIRECTORY_SEPARATOR . $this->options['folder_name'] . DIRECTORY_SEPARATOR . $filename, $output);
				
				if($output==''){
					
					cmsUser::addSessionMessage('Что-то пошло не так', 'error');
					
					} else {
					
					/* Удаляем архивы дампов старше заданного времени */
					exec("find " . PATH . DIRECTORY_SEPARATOR . $this->options['folder_name'] . " -name '*sql.gz' -mtime ".$this->options['store_time']." -exec rm -f {} \\;");
					
					$free = disk_free_space("."); 
					
					cmsUser::addSessionMessage("<script> $('.sess_messages div').css('height', '100%')</script> 
					Бэкап создан.<br/> Свободного места на диске ".showSize($free)." 
					<br/> Размер базы ".showSize($size['size'])."
					<br/> Размер архива ".showSize(filesize(PATH . DIRECTORY_SEPARATOR . $this->options['folder_name'] . DIRECTORY_SEPARATOR . $filename)).
				"<br/> Размер папки с архивами ". showSize(recursiveDirSize(PATH . DIRECTORY_SEPARATOR . $this->options['folder_name'])) .
				runtime(microtime(true) - $start) , 'success');}
				
				
				} else {
				
				cmsUser::addSessionMessage('На диске недостаточно места', 'error');
				
			}
			
			
			
		}
		
	}								